﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace Properties
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            MyClass c = new MyClass();
            c.Ctrl = this;
            propertyGrid1.SelectedObject = c;
            info (this);
        }

        private object tree_obj;

        [ Category ("user") ]
        public void info(object obj)
        {
            tree_obj = obj;

            Type t = obj.GetType();
            TreeNode root = new TreeNode(t.Name);
            treeView1.Nodes.Add(root);

            TreeNode mbranch = new TreeNode("methods");
            root.Nodes.Add(mbranch);

            // using System.Reflection;
            MethodInfo [] met = t.GetMethods();
            foreach (MethodInfo f in met)
            {
                var node = new TreeNode(f.Name);
                node.Tag = f;
                mbranch.Nodes.Add(node);

                object [] attr = f.GetCustomAttributes(true);
                foreach (object a in attr)
                {
                    var sub = new TreeNode("" + a);
                    node.Nodes.Add (sub);
                }
            }

            TreeNode pbranch = new TreeNode("properties");
            root.Nodes.Add(pbranch);

            PropertyInfo[] prop = t.GetProperties();
            foreach (PropertyInfo p in prop)
            {
                var node = new TreeNode(p.Name);
                node.Tag = p;
                pbranch.Nodes.Add(node);
            }

        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            MethodInfo f = e.Node.Tag as MethodInfo;
            if (f != null)
            {
                Type r = f.ReturnType;
                textBox1.Text = "" + r;

                grid.Rows.Clear();
                foreach (ParameterInfo p in f.GetParameters())
                {
                    object[] data = { p.Name, p.ParameterType };
                    grid.Rows.Add(data);
                }

                if (f.GetParameters().Length == 0)
                {
                    // tree_obj.f(values);

                    object[] values = { };
                    try
                    {
                        object result = f.Invoke(tree_obj, values);
                        textBox2.Text = "" + result;
                    }
                    catch (Exception ex)
                    {
                        textBox2.Text = "" + ex;
                    }
                }
            }
        }
    }

}
